import { AVCodecID, AVMediaType } from "@libmedia/avutil/codec";
import { WebAssemblyResource } from "@libmedia/cheap/webassembly/compiler";
export interface ControllerObserver {
    onGetDecoderResource: (mediaType: AVMediaType, codecId: AVCodecID) => Promise<WebAssemblyResource | ArrayBuffer>;
}
export default class Controller {
    private demuxerControlChannel;
    private demuxerControlIPCPort;
    private observer;
    constructor(observer: ControllerObserver);
    getDemuxerRenderControlPort(): MessagePort;
    destroy(): void;
}
