import List from "@libmedia/cheap/std/collection/List";
import { Mutex } from "@libmedia/cheap/thread/mutex";
import { AVFrameRef } from "@libmedia/avutil/struct/avframe";
import AVFramePoolImpl from "@libmedia/avutil/implement/AVFramePoolImpl";
import Pipeline, { TaskOptions } from "@libmedia/avpipeline/Pipeline";
import { FilterGraph, FilterGraphDes, FilterGraphPortDes } from "@libmedia/avfilter/graph";
import AVInputNode from "@libmedia/avfilter/AVInputNode";
import AVOutputNode from "@libmedia/avfilter/AVOutputNode";
export interface AVFilterTaskOptions extends TaskOptions {
    avframeList: pointer<List<pointer<AVFrameRef>>>;
    avframeListMutex: pointer<Mutex>;
    graph: FilterGraphDes;
    inputPorts: FilterGraphPortDes[];
    outputPorts: FilterGraphPortDes[];
}
type SelfTask = AVFilterTaskOptions & {
    avframePool: AVFramePoolImpl;
    filterGraph: FilterGraph;
    inputNodes: AVInputNode[];
    outputNodes: AVOutputNode[];
};
export default class AVFilterPipeline extends Pipeline {
    tasks: Map<string, SelfTask>;
    constructor();
    private createTask;
    registerTask(options: AVFilterTaskOptions): Promise<number>;
    unregisterTask(taskId: string): Promise<void>;
}
export {};
